import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import { trigger, transition, style, animate } from '@angular/animations';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class NgxKuvAlertsService {
    constructor() {
        this.alerts = [];
        this.ids = 1;
        this.timeout = 5000;
    }
    addAlert(text, type = 'warning', icon = '', title = '') {
        let id = this.ids;
        this.alerts.push({
            text: text,
            title: title,
            type: type,
            icon: icon,
            id: id
        });
        this.ids++;
        if (this.timeout > 0) {
            setTimeout(() => {
                let index = this.alerts.findIndex((a) => a.id == id);
                if (index > -1) {
                    this.alerts.splice(index, 1);
                }
            }, this.timeout);
        }
        return id;
    }
    removeAlert(id) {
        let index = this.alerts.findIndex((a) => a.id == id);
        this.alerts.splice(index, 1);
    }
}
NgxKuvAlertsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxKuvAlertsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class NgxKuvAlertsComponent {
    constructor(service) {
        this.service = service;
        this.timeout = 5000;
    }
    ngOnInit() {
        this.service.timeout = this.timeout;
    }
    removeAlert(id) {
        this.service.removeAlert(id);
    }
}
NgxKuvAlertsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsComponent, deps: [{ token: NgxKuvAlertsService }], target: i0.ɵɵFactoryTarget.Component });
NgxKuvAlertsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: NgxKuvAlertsComponent, selector: "kuv-alert", inputs: { timeout: "timeout" }, ngImport: i0, template: "<div class=\"kuv-alert-container\">\n  <div class=\"kuv-alert-list\">\n    <div class=\"kuv-alert\" [ngClass]=\"a.type\" *ngFor=\"let a of service.alerts\" [@alert]>\n      <div class=\"kuv-alert-icon\" *ngIf=\"a.icon\"><i [ngClass]=\"(a.icon.includes('fa-')) ? a.icon : 'fas fa-' + a.icon\"></i>\n      </div>\n      <div class=\"kuv-alert-content\">\n        <div class=\"kuv-alert-title\" *ngIf=\"a.title\">{{a.title}}</div>\n        <div class=\"kuv-alert-text\" [innerHtml]=\"a.text\" *ngIf=\"a.text\"></div>\n      </div>\n      <div class=\"kuv-alert-close\" (click)=\"removeAlert(a.id)\"><i class=\"fas fa-times\"></i>\n      </div>\n    </div>\n  </div>\n</div>", styles: [".kuv-alert-container{z-index:2005;padding:5px;position:fixed;top:1rem;left:25vw}.kuv-alert-container .kuv-alert-list .kuv-alert{margin-bottom:.5rem;display:flex;flex-direction:row;justify-content:space-between;align-items:center;width:50vw;border-radius:5px;box-shadow:0 0 .5rem #00000059!important}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-icon,.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-close{width:50px;height:50px;display:flex;justify-content:center;align-items:center}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-content{display:flex;flex-direction:column;justify-content:flex-start;flex-grow:2;margin:0 1rem}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-content .kuv-alert-title{font-weight:700}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-close{cursor:pointer}.kuv-alert.danger{background-color:#f8d7da;border:#f5c6cb solid 1px;color:#721c24}.kuv-alert.success{background-color:#d4edda;border:#c3e6cb solid 1px;color:#155724}.kuv-alert.kuvemar{background-color:#e4d7f8;border:#d7c6f5 solid 1px;color:#451c72}.kuv-alert.primary{background-color:#cce5ff;border:#d6d8db solid 1px;color:#004085}.kuv-alert.secondary{background-color:#e2e3e5;border:#b8daff solid 1px;color:#383d41}.kuv-alert.warning{background-color:#fff3cd;border:#ffeeba solid 1px;color:#856404}.kuv-alert.info{background-color:#d1ecf1;border:#bee5eb solid 1px;color:#0c5460}.kuv-alert.light{background-color:#fefefe;border:#fdfdfe solid 1px;color:#818182}.kuv-alert.dark{background-color:#d6d8d9;border:#c6c8ca solid 1px;color:#1b1e21}\n"], directives: [{ type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [
        trigger('alert', [
            transition(':enter', [
                style({ transform: 'translateX(100%)', opacity: 0 }),
                animate('.3s ease-out', style({ transform: 'translateX(0%)', opacity: 1 }))
            ]),
            transition(':leave', [
                style({ transform: 'translateX(0%)', opacity: 1 }),
                animate('.3s ease-in', style({ transform: 'translateX(-100%)', opacity: 0 }))
            ])
        ]),
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'kuv-alert', animations: [
                        trigger('alert', [
                            transition(':enter', [
                                style({ transform: 'translateX(100%)', opacity: 0 }),
                                animate('.3s ease-out', style({ transform: 'translateX(0%)', opacity: 1 }))
                            ]),
                            transition(':leave', [
                                style({ transform: 'translateX(0%)', opacity: 1 }),
                                animate('.3s ease-in', style({ transform: 'translateX(-100%)', opacity: 0 }))
                            ])
                        ]),
                    ], template: "<div class=\"kuv-alert-container\">\n  <div class=\"kuv-alert-list\">\n    <div class=\"kuv-alert\" [ngClass]=\"a.type\" *ngFor=\"let a of service.alerts\" [@alert]>\n      <div class=\"kuv-alert-icon\" *ngIf=\"a.icon\"><i [ngClass]=\"(a.icon.includes('fa-')) ? a.icon : 'fas fa-' + a.icon\"></i>\n      </div>\n      <div class=\"kuv-alert-content\">\n        <div class=\"kuv-alert-title\" *ngIf=\"a.title\">{{a.title}}</div>\n        <div class=\"kuv-alert-text\" [innerHtml]=\"a.text\" *ngIf=\"a.text\"></div>\n      </div>\n      <div class=\"kuv-alert-close\" (click)=\"removeAlert(a.id)\"><i class=\"fas fa-times\"></i>\n      </div>\n    </div>\n  </div>\n</div>", styles: [".kuv-alert-container{z-index:2005;padding:5px;position:fixed;top:1rem;left:25vw}.kuv-alert-container .kuv-alert-list .kuv-alert{margin-bottom:.5rem;display:flex;flex-direction:row;justify-content:space-between;align-items:center;width:50vw;border-radius:5px;box-shadow:0 0 .5rem #00000059!important}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-icon,.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-close{width:50px;height:50px;display:flex;justify-content:center;align-items:center}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-content{display:flex;flex-direction:column;justify-content:flex-start;flex-grow:2;margin:0 1rem}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-content .kuv-alert-title{font-weight:700}.kuv-alert-container .kuv-alert-list .kuv-alert .kuv-alert-close{cursor:pointer}.kuv-alert.danger{background-color:#f8d7da;border:#f5c6cb solid 1px;color:#721c24}.kuv-alert.success{background-color:#d4edda;border:#c3e6cb solid 1px;color:#155724}.kuv-alert.kuvemar{background-color:#e4d7f8;border:#d7c6f5 solid 1px;color:#451c72}.kuv-alert.primary{background-color:#cce5ff;border:#d6d8db solid 1px;color:#004085}.kuv-alert.secondary{background-color:#e2e3e5;border:#b8daff solid 1px;color:#383d41}.kuv-alert.warning{background-color:#fff3cd;border:#ffeeba solid 1px;color:#856404}.kuv-alert.info{background-color:#d1ecf1;border:#bee5eb solid 1px;color:#0c5460}.kuv-alert.light{background-color:#fefefe;border:#fdfdfe solid 1px;color:#818182}.kuv-alert.dark{background-color:#d6d8d9;border:#c6c8ca solid 1px;color:#1b1e21}\n"] }]
        }], ctorParameters: function () { return [{ type: NgxKuvAlertsService }]; }, propDecorators: { timeout: [{
                type: Input,
                args: ['timeout']
            }] } });

class NgxKuvAlertsModule {
}
NgxKuvAlertsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxKuvAlertsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsModule, declarations: [NgxKuvAlertsComponent], imports: [CommonModule], exports: [NgxKuvAlertsComponent] });
NgxKuvAlertsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsModule, imports: [[
            CommonModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: NgxKuvAlertsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxKuvAlertsComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        NgxKuvAlertsComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-kuv-alerts
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxKuvAlertsComponent, NgxKuvAlertsModule, NgxKuvAlertsService };
//# sourceMappingURL=ngx-kuv-alerts.mjs.map
